/*
 * THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT. 
 */

#include "varnish_mib.h"
#include "backend.h"

static struct vsm *vsm;
static struct vsc *vsc;

static void     dict_load(struct vsc *vsc);

int
post_config(int majorID, int minorID, void *serverarg, void *clientarg)
{
    vsm = VSM_New();
    if (!vsm) {
        snmp_log(LOG_ERR, "VSM_New: %s\n", strerror(errno));
        return 1;
    }

    vsc = VSC_New();
    if (!vsc) {
        snmp_log(LOG_ERR, "VSC_New: %s\n", strerror(errno));
        return 1;
    }

    if (VSM_Attach(vsm, 2))
        snmp_log(LOG_ERR, "%s\n", VSM_Error(vsm));

    dict_load(vsc);
    backend_collect_addr(vsm);
    return 0;
}

void
varnish_snmp_init(void)
{
    snmp_register_callback(SNMP_CALLBACK_LIBRARY,
                           SNMP_CALLBACK_POST_READ_CONFIG,
                           post_config, NULL);
}

void
varnish_snmp_deinit(void)
{
    /*
     * FIXME? 
     */
}

struct vsm     *
varnish_get_vsm_data(void)
{
    if (vsm) {
        if (VSM_Status(vsm) & (VSM_MGT_CHANGED | VSM_WRK_CHANGED)) {
            DEBUGMSGTL(("varnish_mib", "reopening vsm\n"));
            dict_load(vsc);
            backend_collect_addr(vsm);
        }
    }
    return vsm;
}

enum vmib_oid {
    backendConnToMany,
    backendConnSuccess,
    backendConnFailures,
    backendConnRecycled,
    backendRequests,
    backendConnRetry,
    backendConnReuses,
    backendConnNotAttempted,
    bansTotal,
    bansAdded,
    bansCompleted,
    bansDeleted,
    bansDups,
    bansLurkerContention,
    bansLurkerObjKilled,
    bansLurkerTested,
    bansLurkerTestTested,
    bansObj,
    bansObjectsKilled,
    bansPersistedBytes,
    bansPersistedFragmentation,
    bansReq,
    bansTested,
    bansTestTested,
    clientCacheHits,
    clientCacheHitsPass,
    clientCacheMisses,
    clientRequestsReceived,
    totalRequests = clientRequestsReceived,
    clientRequests400,
    clientRequests417,
    objectsExpired,
    objectsGunzip,
    objectsGzip,
    objectsLRUMoved,
    objectsLRUNuked,
    objectsObjPurged,
    objectsCount,
    objectsCore,
    objectsHead,
    objectsPurges,
    objectsVampire,
    vclTotal,
    vclAvail,
    vclDiscard,
    threadsPools,
    totalFetch,
    totalPass,
    sessPipeline,
    totalPipe = sessPipeline,
    totalPipeHeaderBytes,
    totalPipeIn,
    totalPipeOut,
    totalRequestBodyBytes,
    totalRequestHeaderBytes,
    totalResponseBodyBytes,
    totalResponseHeaderBytes,
    totalSessions,
    sessPipeOverflow,
    sessClosed,
    sessAccepted,
    clientAcceptedConnections = sessAccepted,
    sessDrop,
    sessDropped,
    sessFail,
    sessHerd,
    sessQueued,
    sessReadAhead,
    threadsQueueLength,
    threadsTotal,
    threadsCreated,
    threadsDestroyed,
    threadsFailed,
    threadsLimitHits,
    uptime,
    vclFail,
    MAX_VMIB_OID
};

static char const *vmib_name_table[] = {
    "MAIN.backend_busy",
    "MAIN.backend_conn",
    "MAIN.backend_fail",
    "MAIN.backend_recycle",
    "MAIN.backend_req",
    "MAIN.backend_retry",
    "MAIN.backend_reuse",
    "MAIN.backend_unhealthy",
    "MAIN.bans",
    "MAIN.bans_added",
    "MAIN.bans_completed",
    "MAIN.bans_deleted",
    "MAIN.bans_dups",
    "MAIN.bans_lurker_contention",
    "MAIN.bans_lurker_obj_killed",
    "MAIN.bans_lurker_tested",
    "MAIN.bans_lurker_tests_tested",
    "MAIN.bans_obj",
    "MAIN.bans_obj_killed",
    "MAIN.bans_persisted_bytes",
    "MAIN.bans_persisted_fragmentation",
    "MAIN.bans_req",
    "MAIN.bans_tested",
    "MAIN.bans_tests_tested",
    "MAIN.cache_hit",
    "MAIN.cache_hitpass",
    "MAIN.cache_miss",
    "MAIN.client_req",
    "MAIN.client_req_400",
    "MAIN.client_req_417",
    "MAIN.n_expired",
    "MAIN.n_gunzip",
    "MAIN.n_gzip",
    "MAIN.n_lru_moved",
    "MAIN.n_lru_nuked",
    "MAIN.n_obj_purged",
    "MAIN.n_object",
    "MAIN.n_objectcore",
    "MAIN.n_objecthead",
    "MAIN.n_purges",
    "MAIN.n_vampireobject",
    "MAIN.n_vcl",
    "MAIN.n_vcl_avail",
    "MAIN.n_vcl_discard",
    "MAIN.pools",
    "MAIN.s_fetch",
    "MAIN.s_pass",
    "MAIN.s_pipe",
    "MAIN.s_pipe_hdrbytes",
    "MAIN.s_pipe_in",
    "MAIN.s_pipe_out",
    "MAIN.s_req_bodybytes",
    "MAIN.s_req_hdrbytes",
    "MAIN.s_resp_bodybytes",
    "MAIN.s_resp_hdrbytes",
    "MAIN.s_sess",
    "MAIN.sc_pipe_overflow",
    "MAIN.sess_closed",
    "MAIN.sess_conn",
    "MAIN.sess_drop",
    "MAIN.sess_dropped",
    "MAIN.sess_fail",
    "MAIN.sess_herd",
    "MAIN.sess_queued",
    "MAIN.sess_readahead",
    "MAIN.thread_queue_len",
    "MAIN.threads",
    "MAIN.threads_created",
    "MAIN.threads_destroyed",
    "MAIN.threads_failed",
    "MAIN.threads_limited",
    "MAIN.uptime",
    "MAIN.vcl_fail",
};

static const volatile uint64_t *vmib_data_table[73];

static int      vmib_hash_table[] = {
    -1, -1, -1, -1, -1, -1, -1, -1, 65, -1,
    67, 60, 25, -1, 71, -1, -1, -1, 11, -1,
    -1, 20, -1, -1, 32, -1, -1, -1, -1, 13,
    70, 28, 43, -1, -1, -1, -1, -1, 42, -1,
    -1, -1, 50, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, 62, -1, -1, -1, -1,
    -1, -1, -1, 48, -1, 33, -1, -1, 66, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, 27, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, 51, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, 35, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, 9,
    -1, -1, -1, -1, -1, -1, 24, -1, -1, -1,
    -1, 61, -1, -1, 49, -1, 3, -1, -1, -1,
    -1, 46, -1, -1, -1, -1, -1, 68, -1, -1,
    -1, -1, 37, -1, -1, -1, 29, -1, -1, -1,
    -1, -1, -1, -1, -1, 0, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, 39, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    17, -1, -1, -1, -1, 22, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, 5, -1, -1, -1, -1, -1, -1,
    -1, 72, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, 47,
    -1, -1, -1, -1, -1, 59, -1, 6, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, 18, -1, -1,
    2, 10, 69, -1, -1, -1, -1, 40, -1, -1,
    -1, -1, 54, -1, -1, 58, -1, -1, 31, -1,
    -1, -1, -1, 14, -1, -1, -1, -1, -1, -1,
    -1, 53, -1, -1, -1, -1, -1, 38, -1, -1,
    -1, -1, -1, -1, -1, -1, 26, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, 36, -1, -1,
    -1, -1, -1, -1, 15, -1, -1, -1, -1, -1,
    -1, 23, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, 41, -1, 45,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, 21,
    -1, -1, -1, -1, -1, -1, 56, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, 4, -1, 44, -1,
    -1, -1, -1, -1, -1, -1, 7, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, 64,
    -1, 34, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, 1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, 57, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, 52,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, 8, -1, -1, -1, -1, -1, 63, -1,
    12, -1, 30, -1, -1, 55, 16, -1, -1, -1,
    -1, 19, -1, -1,
};

unsigned        vmib_hash_table_size =
    sizeof(vmib_hash_table) / sizeof(vmib_hash_table[0]);

#ifndef CHAR_BIT
# define CHAR_BIT 8
#endif
#ifndef UINT_MAX
# define UINT_MAX ((unsigned)-1)
#endif

static inline unsigned
rotl_sz(unsigned x, int n)
{
    return ((x << n) | (x >> ((CHAR_BIT * sizeof x) - n))) & UINT_MAX;
}

static unsigned
string_hash(const char *str, unsigned size)
{
    unsigned        value = 0;
    unsigned char   ch;

    for (; (ch = *str); str++)
        value = ch + rotl_sz(value, 7);
    return value % size;
}


static const volatile uint64_t **
varnish_var_lookup(char const *str)
{
    if (str) {
        int             i, h;

        h = string_hash(str, vmib_hash_table_size);
        i = h;
        while (vmib_hash_table[i] != -1) {
            if (strcmp(vmib_name_table[vmib_hash_table[i]], str) == 0)
                return &vmib_data_table[vmib_hash_table[i]];
            i = (i + 1) % vmib_hash_table_size;
            if (i == h)
                break;
        }
    }
    return NULL;
}

static inline const volatile uint64_t *
varnish_get_oid(int i)
{
    return vmib_data_table[i];
}

static void
dict_clear(void)
{
    int             i;
    for (i = 0; i < MAX_VMIB_OID; i++)
        vmib_data_table[i] = NULL;
}

static void
dict_install(struct VSC_point const *pt)
{
    const volatile uint64_t **ent;

    ent = varnish_var_lookup(pt->name);
    if (ent)
        *ent = pt->ptr;
}

static int
load_cb(void *priv, const struct VSC_point *vpt)
{
    AZ(strcmp(vpt->ctype, "uint64_t"));
    if (strncmp(vpt->name, "VBE.", 4) == 0) {
        char const     *name = vpt->name + 4;
        char           *p = strrchr(name, '.');
        if (p) {
            backend_register(name, p - name, p + 1, vpt);
        }
    }
    dict_install(vpt);
    return 0;
}

static void
dict_load(struct vsc *vsc)
{
    dict_clear();
    backend_clear();
    VSC_Iter(vsc, vsm, load_cb, NULL);
}

/*
 * Variable handlers.
 * 
 * An instance handler only hands us one request at a time, unwrapping
 * any eventual GETNEXT requests.  
 */


static int
handle_clientAcceptedConnections(netsnmp_mib_handler *handler,
                                 netsnmp_handler_registration *reginfo,
                                 netsnmp_agent_request_info *reqinfo,
                                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientAcceptedConnections);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientAcceptedConnections\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientRequestsReceived(netsnmp_mib_handler *handler,
                              netsnmp_handler_registration *reginfo,
                              netsnmp_agent_request_info *reqinfo,
                              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientRequestsReceived);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequestsReceived\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientCacheHits(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientCacheHits);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_clientCacheHits\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientCacheHitsPass(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientCacheHitsPass);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientCacheHitsPass\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientCacheMisses(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientCacheMisses);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientCacheMisses\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientBan(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{
    int             ret;

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const char     *s = "";
            snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                     s, strlen(s));
        }
        break;

        /*
         * SET REQUEST
         *
         * multiple states in the transaction.  See:
         * http://www.net-snmp.org/tutorial-5/toolkit/mib_module/set-actions.jpg
         */
    case MODE_SET_RESERVE1:
        /*
         * or you could use netsnmp_check_vb_type_and_size instead 
         */
        ret = netsnmp_check_vb_type(requests->requestvb, ASN_OCTET_STR);
        if (ret != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, ret);
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        ret = varnish_ban(reqinfo, requests, vsm);
        if (ret != SNMP_ERR_NOERROR)
            netsnmp_set_request_error(reqinfo, requests, ret);
        break;

    case MODE_SET_COMMIT:
        break;

    case MODE_SET_UNDO:
        break;

    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_clientBan\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientRequests400(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientRequests400);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests400\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_clientRequests417(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(clientRequests417);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_clientRequests417\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnSuccess(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnSuccess);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnSuccess\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnNotAttempted(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnNotAttempted);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnNotAttempted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnToMany(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnToMany);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnToMany\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnFailures(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnFailures);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnFailures\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnReuses(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnReuses);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnReuses\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnRecycled(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnRecycled);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_backendConnRecycled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendConnRetry(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendConnRetry);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_backendConnRetry\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_backendRequests(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(backendRequests);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_backendRequests\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalSessions(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalSessions);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalSessions\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalRequests(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalRequests);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalRequests\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalPipe(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalPipe);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipe\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalPass(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalPass);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPass\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalFetch(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalFetch);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalFetch\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalRequestHeaderBytes(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(totalRequestHeaderBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalRequestHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalRequestBodyBytes(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *reqinfo,
                             netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(totalRequestBodyBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalRequestBodyBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalResponseHeaderBytes(netsnmp_mib_handler *handler,
                                netsnmp_handler_registration *reginfo,
                                netsnmp_agent_request_info *reqinfo,
                                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(totalResponseHeaderBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalResponseHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalResponseBodyBytes(netsnmp_mib_handler *handler,
                              netsnmp_handler_registration *reginfo,
                              netsnmp_agent_request_info *reqinfo,
                              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(totalResponseBodyBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalResponseBodyBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalPipeHeaderBytes(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(totalPipeHeaderBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_totalPipeHeaderBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalPipeIn(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalPipeIn);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipeIn\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_totalPipeOut(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(totalPipeOut);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_totalPipeOut\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_uptime(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(uptime);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            val *= 100;
            snmp_set_var_typed_value(requests->requestvb, ASN_TIMETICKS,
                                     &val, sizeof(val));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_uptime\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessAccepted(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessAccepted);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessAccepted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessQueued(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessQueued);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessQueued\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessDropped(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessDropped);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessDropped\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessClosed(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessClosed);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessClosed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessPipeline(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessPipeline);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessPipeline\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessReadAhead(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessReadAhead);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessReadAhead\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessHerd(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessHerd);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessHerd\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessDrop(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessDrop);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessDrop\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessFail(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(sessFail);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessFail\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_sessPipeOverflow(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(sessPipeOverflow);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_sessPipeOverflow\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsPools(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(threadsPools);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsPools\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsTotal(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(threadsTotal);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsLimitHits(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(threadsLimitHits);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsLimitHits\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsCreated(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(threadsCreated);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsCreated\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsDestroyed(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(threadsDestroyed);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsDestroyed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsFailed(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(threadsFailed);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_threadsFailed\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_threadsQueueLength(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(threadsQueueLength);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_threadsQueueLength\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansTotal(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansTotal);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansCompleted(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansCompleted);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansCompleted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansObj(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansObj);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansObj\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansReq(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansReq);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansReq\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansAdded(netsnmp_mib_handler *handler,
                 netsnmp_handler_registration *reginfo,
                 netsnmp_agent_request_info *reqinfo,
                 netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansAdded);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansAdded\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansDeleted(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansDeleted);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansDeleted\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansTested(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansTested);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansObjectsKilled(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansObjectsKilled);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansObjectsKilled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansLurkerTested(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansLurkerTested);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansLurkerTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansTestTested(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansTestTested);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansTestTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansLurkerTestTested(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansLurkerTestTested);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerTestTested\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansLurkerObjKilled(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansLurkerObjKilled);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerObjKilled\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansDups(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(bansDups);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_bansDups\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansLurkerContention(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansLurkerContention);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansLurkerContention\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansPersistedBytes(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansPersistedBytes);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansPersistedBytes\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_bansPersistedFragmentation(netsnmp_mib_handler *handler,
                                  netsnmp_handler_registration *reginfo,
                                  netsnmp_agent_request_info *reqinfo,
                                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(bansPersistedFragmentation);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_bansPersistedFragmentation\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsCount(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsCount);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsCount\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsVampire(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsVampire);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsVampire\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsCore(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsCore);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsCore\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsHead(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsHead);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsHead\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsExpired(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsExpired);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsExpired\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsLRUNuked(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(objectsLRUNuked);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsLRUNuked\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsLRUMoved(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(objectsLRUMoved);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsLRUMoved\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsPurges(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsPurges);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsPurges\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsObjPurged(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent =
                varnish_get_oid(objectsObjPurged);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsObjPurged\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsGzip(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsGzip);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsGzip\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_objectsGunzip(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(objectsGunzip);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_objectsGunzip\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_vclTotal(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(vclTotal);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclTotal\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_vclAvail(netsnmp_mib_handler *handler,
                netsnmp_handler_registration *reginfo,
                netsnmp_agent_request_info *reqinfo,
                netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(vclAvail);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclAvail\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_vclDiscard(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(vclDiscard);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclDiscard\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


static int
handle_vclFail(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
{

    if (!varnish_get_vsm_data())
        return SNMP_ERR_NOSUCHNAME;

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            const volatile uint64_t *ent = varnish_get_oid(vclFail);
            uint64_t        val;

            if (!ent)
                return SNMP_ERR_NOSUCHNAME;
            val = *ent;
            {
                struct counter64 ctr;
                ctr.high = val >> 32;
                ctr.low = val & 0xffffffff;
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64, &ctr, sizeof(ctr));
            }
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_vclFail\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}




/** handles requests for the backendTable table */
static int
handle_table_backendTable(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct backendTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct backendTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_VBEIDENT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIdent,
                                         table_entry->vbeIdent_len);
                break;
            case COLUMN_VBEIPV4:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIPv4,
                                         table_entry->vbeIPv4_len);
                break;
            case COLUMN_VBEIPV6:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->vbeIPv6,
                                         table_entry->vbeIPv6_len);
                break;
            case COLUMN_VBEPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb,
                                           ASN_UNSIGNED,
                                           table_entry->vbePort);
                break;
            case COLUMN_VBEHAPPYPROBES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeHappyProbes,
                                         sizeof(table_entry->
                                                vbeHappyProbes));
                break;
            case COLUMN_VBEVCLS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeVcls,
                                         sizeof(table_entry->vbeVcls));
                break;
            case COLUMN_VBEREQUESTHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeRequestHeaderBytes,
                                         sizeof(table_entry->
                                                vbeRequestHeaderBytes));
                break;
            case COLUMN_VBEREQUESTBODYBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbeRequestBodyBytes,
                                         sizeof(table_entry->
                                                vbeRequestBodyBytes));
                break;
            case COLUMN_VBERESPONSEHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeResponseHeaderBytes,
                                         sizeof(table_entry->
                                                vbeResponseHeaderBytes));
                break;
            case COLUMN_VBERESPONSEBODYBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->
                                         vbeResponseBodyBytes,
                                         sizeof(table_entry->
                                                vbeResponseBodyBytes));
                break;
            case COLUMN_VBEPIPEHEADERBYTES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeHeaderBytes,
                                         sizeof(table_entry->
                                                vbePipeHeaderBytes));
                break;
            case COLUMN_VBEPIPEIN:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeIn,
                                         sizeof(table_entry->vbePipeIn));
                break;
            case COLUMN_VBEPIPEOUT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(requests->requestvb,
                                         ASN_COUNTER64,
                                         &table_entry->vbePipeOut,
                                         sizeof(table_entry->vbePipeOut));
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_table_backendTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the backendTable table by defining its contents and how it's structured */
static void
initialize_table_backendTable(void)
{
    const oid       backendTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 3 };
    const size_t    backendTable_oid_len = OID_LENGTH(backendTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("varnish_mib", "initializing table backendTable\n"));

    reg =
        netsnmp_create_handler_registration("backendTable",
                                            handle_table_backendTable,
                                            backendTable_oid,
                                            backendTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("backendTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR, "error creating tdata table for backendTable\n");
        return;
    }
    cache = netsnmp_cache_create(backendTable_timeout,
                                 backendTable_load, backendTable_free,
                                 backendTable_oid, backendTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR, "error creating cache for backendTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR, "error creating table info for backendTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: vbeIndex */
                                     0);

    table_info->min_column = COLUMN_VBEIDENT;
    table_info->max_column = COLUMN_VBEPIPEOUT;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}



/** handles requests for the banTable table */
static int
handle_table_banTable(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct banTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct banTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_BANTIME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->banTime,
                                         table_entry->banTime_len);
                break;
            case COLUMN_BANREFCOUNT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->banRefCount);
                break;
            case COLUMN_BANEXPRESSION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->banExpression,
                                         table_entry->banExpression_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_table_banTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the banTable table by defining its contents and how it's structured */
static void
initialize_table_banTable(void)
{
    const oid       banTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 18 };
    const size_t    banTable_oid_len = OID_LENGTH(banTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("varnish_mib", "initializing table banTable\n"));

    reg =
        netsnmp_create_handler_registration("banTable",
                                            handle_table_banTable,
                                            banTable_oid, banTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("banTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR, "error creating tdata table for banTable\n");
        return;
    }
    cache = netsnmp_cache_create(banTable_timeout,
                                 banTable_load, banTable_free,
                                 banTable_oid, banTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR, "error creating cache for banTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR, "error creating table info for banTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: banIndex */
                                     0);

    table_info->min_column = COLUMN_BANTIME;
    table_info->max_column = COLUMN_BANEXPRESSION;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}


/** Initializes the varnish_mib.c module */
void
init_varnish_mib(void)
{
    if (vsm) {
        snmp_log(LOG_ERR, "%s: can't be loaded twice\n", "varnish_mib");
        abort();
    }

    const oid       clientAcceptedConnections_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 1 };


    const oid       clientRequestsReceived_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 2 };


    const oid       clientCacheHits_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 3 };


    const oid       clientCacheHitsPass_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 4 };


    const oid       clientCacheMisses_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 5 };


    const oid       clientBan_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 6 };


    const oid       clientRequests400_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 7 };


    const oid       clientRequests417_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 1, 10 };


    const oid       backendConnSuccess_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 1 };


    const oid       backendConnNotAttempted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 2 };


    const oid       backendConnToMany_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 3 };


    const oid       backendConnFailures_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 4 };


    const oid       backendConnReuses_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 5 };


    const oid       backendConnRecycled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 6 };


    const oid       backendConnRetry_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 1, 8 };


    const oid       backendRequests_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 2, 2 };


    const oid       totalSessions_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 1 };


    const oid       totalRequests_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 2 };


    const oid       totalPipe_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 3 };


    const oid       totalPass_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 4 };


    const oid       totalFetch_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 5 };


    const oid       totalRequestHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 6 };


    const oid       totalRequestBodyBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 7 };


    const oid       totalResponseHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 8 };


    const oid       totalResponseBodyBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 9 };


    const oid       totalPipeHeaderBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 10 };


    const oid       totalPipeIn_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 11 };


    const oid       totalPipeOut_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 3, 12 };


    const oid       uptime_oid[] = { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 4, 1 };


    const oid       sessAccepted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 1 };


    const oid       sessQueued_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 2 };


    const oid       sessDropped_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 3 };


    const oid       sessClosed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 4 };


    const oid       sessPipeline_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 5 };


    const oid       sessReadAhead_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 6 };


    const oid       sessHerd_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 7 };


    const oid       sessDrop_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 8 };


    const oid       sessFail_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 9 };


    const oid       sessPipeOverflow_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 5, 10 };


    const oid       threadsPools_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 1 };


    const oid       threadsTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 2 };


    const oid       threadsLimitHits_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 3 };


    const oid       threadsCreated_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 4 };


    const oid       threadsDestroyed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 5 };


    const oid       threadsFailed_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 6 };


    const oid       threadsQueueLength_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 6, 7 };


    const oid       bansTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 1 };


    const oid       bansCompleted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 2 };


    const oid       bansObj_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 3 };


    const oid       bansReq_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 4 };


    const oid       bansAdded_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 5 };


    const oid       bansDeleted_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 6 };


    const oid       bansTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 7 };


    const oid       bansObjectsKilled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 8 };


    const oid       bansLurkerTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 9 };


    const oid       bansTestTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 10 };


    const oid       bansLurkerTestTested_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 11 };


    const oid       bansLurkerObjKilled_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 12 };


    const oid       bansDups_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 13 };


    const oid       bansLurkerContention_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 14 };


    const oid       bansPersistedBytes_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 15 };


    const oid       bansPersistedFragmentation_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 7, 17 };


    const oid       objectsCount_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 1 };


    const oid       objectsVampire_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 2 };


    const oid       objectsCore_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 3 };


    const oid       objectsHead_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 4 };


    const oid       objectsExpired_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 5 };


    const oid       objectsLRUNuked_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 6 };


    const oid       objectsLRUMoved_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 7 };


    const oid       objectsPurges_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 8 };


    const oid       objectsObjPurged_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 9 };


    const oid       objectsGzip_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 10 };


    const oid       objectsGunzip_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 9, 11 };


    const oid       vclTotal_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 1 };


    const oid       vclAvail_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 2 };


    const oid       vclDiscard_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 3 };


    const oid       vclFail_oid[] =
        { 1, 3, 6, 1, 4, 1, 33043, 6, 1, 10, 4 };


    DEBUGMSGTL(("varnish_mib", "Initializing\n"));

    varnish_mib_config_init();


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientAcceptedConnections",
                             handle_clientAcceptedConnections,
                             clientAcceptedConnections_oid,
                             OID_LENGTH(clientAcceptedConnections_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequestsReceived",
                             handle_clientRequestsReceived,
                             clientRequestsReceived_oid,
                             OID_LENGTH(clientRequestsReceived_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheHits", handle_clientCacheHits,
                             clientCacheHits_oid,
                             OID_LENGTH(clientCacheHits_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheHitsPass",
                             handle_clientCacheHitsPass,
                             clientCacheHitsPass_oid,
                             OID_LENGTH(clientCacheHitsPass_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientCacheMisses", handle_clientCacheMisses,
                             clientCacheMisses_oid,
                             OID_LENGTH(clientCacheMisses_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientBan", handle_clientBan, clientBan_oid,
                             OID_LENGTH(clientBan_oid),
                             HANDLER_CAN_RWRITE));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests400", handle_clientRequests400,
                             clientRequests400_oid,
                             OID_LENGTH(clientRequests400_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("clientRequests417", handle_clientRequests417,
                             clientRequests417_oid,
                             OID_LENGTH(clientRequests417_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnSuccess",
                             handle_backendConnSuccess,
                             backendConnSuccess_oid,
                             OID_LENGTH(backendConnSuccess_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnNotAttempted",
                             handle_backendConnNotAttempted,
                             backendConnNotAttempted_oid,
                             OID_LENGTH(backendConnNotAttempted_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnToMany", handle_backendConnToMany,
                             backendConnToMany_oid,
                             OID_LENGTH(backendConnToMany_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnFailures",
                             handle_backendConnFailures,
                             backendConnFailures_oid,
                             OID_LENGTH(backendConnFailures_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnReuses", handle_backendConnReuses,
                             backendConnReuses_oid,
                             OID_LENGTH(backendConnReuses_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnRecycled",
                             handle_backendConnRecycled,
                             backendConnRecycled_oid,
                             OID_LENGTH(backendConnRecycled_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendConnRetry", handle_backendConnRetry,
                             backendConnRetry_oid,
                             OID_LENGTH(backendConnRetry_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("backendRequests", handle_backendRequests,
                             backendRequests_oid,
                             OID_LENGTH(backendRequests_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalSessions", handle_totalSessions,
                             totalSessions_oid,
                             OID_LENGTH(totalSessions_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequests", handle_totalRequests,
                             totalRequests_oid,
                             OID_LENGTH(totalRequests_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipe", handle_totalPipe, totalPipe_oid,
                             OID_LENGTH(totalPipe_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPass", handle_totalPass, totalPass_oid,
                             OID_LENGTH(totalPass_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalFetch", handle_totalFetch,
                             totalFetch_oid, OID_LENGTH(totalFetch_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequestHeaderBytes",
                             handle_totalRequestHeaderBytes,
                             totalRequestHeaderBytes_oid,
                             OID_LENGTH(totalRequestHeaderBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalRequestBodyBytes",
                             handle_totalRequestBodyBytes,
                             totalRequestBodyBytes_oid,
                             OID_LENGTH(totalRequestBodyBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalResponseHeaderBytes",
                             handle_totalResponseHeaderBytes,
                             totalResponseHeaderBytes_oid,
                             OID_LENGTH(totalResponseHeaderBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalResponseBodyBytes",
                             handle_totalResponseBodyBytes,
                             totalResponseBodyBytes_oid,
                             OID_LENGTH(totalResponseBodyBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeHeaderBytes",
                             handle_totalPipeHeaderBytes,
                             totalPipeHeaderBytes_oid,
                             OID_LENGTH(totalPipeHeaderBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeIn", handle_totalPipeIn,
                             totalPipeIn_oid, OID_LENGTH(totalPipeIn_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("totalPipeOut", handle_totalPipeOut,
                             totalPipeOut_oid,
                             OID_LENGTH(totalPipeOut_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("uptime", handle_uptime, uptime_oid,
                             OID_LENGTH(uptime_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessAccepted", handle_sessAccepted,
                             sessAccepted_oid,
                             OID_LENGTH(sessAccepted_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessQueued", handle_sessQueued,
                             sessQueued_oid, OID_LENGTH(sessQueued_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessDropped", handle_sessDropped,
                             sessDropped_oid, OID_LENGTH(sessDropped_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessClosed", handle_sessClosed,
                             sessClosed_oid, OID_LENGTH(sessClosed_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessPipeline", handle_sessPipeline,
                             sessPipeline_oid,
                             OID_LENGTH(sessPipeline_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessReadAhead", handle_sessReadAhead,
                             sessReadAhead_oid,
                             OID_LENGTH(sessReadAhead_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessHerd", handle_sessHerd, sessHerd_oid,
                             OID_LENGTH(sessHerd_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessDrop", handle_sessDrop, sessDrop_oid,
                             OID_LENGTH(sessDrop_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessFail", handle_sessFail, sessFail_oid,
                             OID_LENGTH(sessFail_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("sessPipeOverflow", handle_sessPipeOverflow,
                             sessPipeOverflow_oid,
                             OID_LENGTH(sessPipeOverflow_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsPools", handle_threadsPools,
                             threadsPools_oid,
                             OID_LENGTH(threadsPools_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsTotal", handle_threadsTotal,
                             threadsTotal_oid,
                             OID_LENGTH(threadsTotal_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsLimitHits", handle_threadsLimitHits,
                             threadsLimitHits_oid,
                             OID_LENGTH(threadsLimitHits_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsCreated", handle_threadsCreated,
                             threadsCreated_oid,
                             OID_LENGTH(threadsCreated_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsDestroyed", handle_threadsDestroyed,
                             threadsDestroyed_oid,
                             OID_LENGTH(threadsDestroyed_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsFailed", handle_threadsFailed,
                             threadsFailed_oid,
                             OID_LENGTH(threadsFailed_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("threadsQueueLength",
                             handle_threadsQueueLength,
                             threadsQueueLength_oid,
                             OID_LENGTH(threadsQueueLength_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTotal", handle_bansTotal, bansTotal_oid,
                             OID_LENGTH(bansTotal_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansCompleted", handle_bansCompleted,
                             bansCompleted_oid,
                             OID_LENGTH(bansCompleted_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansObj", handle_bansObj, bansObj_oid,
                             OID_LENGTH(bansObj_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansReq", handle_bansReq, bansReq_oid,
                             OID_LENGTH(bansReq_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansAdded", handle_bansAdded, bansAdded_oid,
                             OID_LENGTH(bansAdded_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansDeleted", handle_bansDeleted,
                             bansDeleted_oid, OID_LENGTH(bansDeleted_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTested", handle_bansTested,
                             bansTested_oid, OID_LENGTH(bansTested_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansObjectsKilled", handle_bansObjectsKilled,
                             bansObjectsKilled_oid,
                             OID_LENGTH(bansObjectsKilled_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerTested", handle_bansLurkerTested,
                             bansLurkerTested_oid,
                             OID_LENGTH(bansLurkerTested_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansTestTested", handle_bansTestTested,
                             bansTestTested_oid,
                             OID_LENGTH(bansTestTested_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerTestTested",
                             handle_bansLurkerTestTested,
                             bansLurkerTestTested_oid,
                             OID_LENGTH(bansLurkerTestTested_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerObjKilled",
                             handle_bansLurkerObjKilled,
                             bansLurkerObjKilled_oid,
                             OID_LENGTH(bansLurkerObjKilled_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansDups", handle_bansDups, bansDups_oid,
                             OID_LENGTH(bansDups_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansLurkerContention",
                             handle_bansLurkerContention,
                             bansLurkerContention_oid,
                             OID_LENGTH(bansLurkerContention_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansPersistedBytes",
                             handle_bansPersistedBytes,
                             bansPersistedBytes_oid,
                             OID_LENGTH(bansPersistedBytes_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("bansPersistedFragmentation",
                             handle_bansPersistedFragmentation,
                             bansPersistedFragmentation_oid,
                             OID_LENGTH(bansPersistedFragmentation_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsCount", handle_objectsCount,
                             objectsCount_oid,
                             OID_LENGTH(objectsCount_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsVampire", handle_objectsVampire,
                             objectsVampire_oid,
                             OID_LENGTH(objectsVampire_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsCore", handle_objectsCore,
                             objectsCore_oid, OID_LENGTH(objectsCore_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsHead", handle_objectsHead,
                             objectsHead_oid, OID_LENGTH(objectsHead_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsExpired", handle_objectsExpired,
                             objectsExpired_oid,
                             OID_LENGTH(objectsExpired_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsLRUNuked", handle_objectsLRUNuked,
                             objectsLRUNuked_oid,
                             OID_LENGTH(objectsLRUNuked_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsLRUMoved", handle_objectsLRUMoved,
                             objectsLRUMoved_oid,
                             OID_LENGTH(objectsLRUMoved_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsPurges", handle_objectsPurges,
                             objectsPurges_oid,
                             OID_LENGTH(objectsPurges_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsObjPurged", handle_objectsObjPurged,
                             objectsObjPurged_oid,
                             OID_LENGTH(objectsObjPurged_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsGzip", handle_objectsGzip,
                             objectsGzip_oid, OID_LENGTH(objectsGzip_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("objectsGunzip", handle_objectsGunzip,
                             objectsGunzip_oid,
                             OID_LENGTH(objectsGunzip_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclTotal", handle_vclTotal, vclTotal_oid,
                             OID_LENGTH(vclTotal_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclAvail", handle_vclAvail, vclAvail_oid,
                             OID_LENGTH(vclAvail_oid), HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclDiscard", handle_vclDiscard,
                             vclDiscard_oid, OID_LENGTH(vclDiscard_oid),
                             HANDLER_CAN_RONLY));


    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("vclFail", handle_vclFail, vclFail_oid,
                             OID_LENGTH(vclFail_oid), HANDLER_CAN_RONLY));

    initialize_table_backendTable();
    initialize_table_banTable();
    varnish_snmp_init();
}

void
deinit_varnish_mib(void)
{
    varnish_snmp_deinit();
}

/*
 * Local variables:
 * buffer-read-only: t
 * End:
 * vi: set ro:
 */
